/*
 *    GS2LuceneRetrieve.java
 *    Copyright (C) 2005 New Zealand Digital Library, http://www.nzdl.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package org.greenstone.gsdl3.service;

// Greenstone classes
import org.greenstone.mgpp.*;
import org.greenstone.gsdl3.core.GSException;
import org.greenstone.gsdl3.util.GSFile;
import org.greenstone.gsdl3.util.GSXML;

// XML classes
import org.w3c.dom.Element;
import org.w3c.dom.Text;

// General Java classes
import java.io.File;

import org.apache.log4j.Category;

public class GS2LuceneRetrieve
    extends AbstractGS2DocumentRetrieve
{
     static Category logger = Category.getInstance(org.greenstone.gsdl3.service.GS2LuceneRetrieve.class.getName());

     // Parameters used
    private static final String LEVEL_PARAM = "level";

    // Elements used in the config file that are specific to this class
    private static final String DEFAULT_LEVEL_ELEM = "defaultLevel";

    private MGPPWrapper mgpp_src = null;
    
    private String default_level = null;
    private String mgpp_textdir = null;
	
    public GS2LuceneRetrieve() {
	this.mgpp_src = new MGPPWrapper();
    }

    public void cleanUp() {
	super.cleanUp();
	this.mgpp_src.unloadIndexData();
    }

    /** configure this service */
    public boolean configure(Element info, Element extra_info)
    {
	if (!super.configure(info, extra_info)){
	    return false;
	}

	// Do specific configuration
	logger.info("Configuring GS2LuceneRetrieve...");

	// TODO - is there anything we need to do here? 
	// set up XML parser??

	return true;
 
    }
    
    /** returns the content of a node
     * should return a nodeContent element:
     * <nodeContent>text content or other elements</nodeContent>
     */
    protected Element getNodeContent(String doc_id) throws GSException {

	
	Element content_node = this.doc.createElement(GSXML.NODE_CONTENT_ELEM);
	
	String doc_content = "";
	try {
	    // TODO get the doc content from the index text dir
	} catch (Exception e) {
	    logger.info("exception happended getting doc content for " + doc_id); 
	    doc_content = "dummy content for doc "+doc_id +"\n";

	}

	Text t = this.doc.createTextNode(doc_content);
	content_node.appendChild(t);
	return content_node;
    }


}
